using Insight.Infrastructure;
using Insight.Infrastructure.Entities;
using Insight.Web.Components.Containers;
using Insight.Web.Constants;
using Microsoft.AspNetCore.Components;
using MongoDB.Bson;
using MongoDB.Driver;
using MudBlazor;
using System.Text.RegularExpressions;
using SortDirection = MudBlazor.SortDirection;

namespace Insight.Web.Pages.Management.Hosts.Network.Addresses;

[Route(Navigation.Management.Hosts.Network.Addresses.Index)]
public partial class Index
{
    [Parameter] public string? HostId { get; set; }

    [Inject] private IMongoDatabase Database { get; init; } = default!;
    [Inject] private ISnackbar Snackbar { get; init; } = default!;
    [Inject] private NavigationManager NavigationManager { get; init; } = default!;

    private TableContainer<HostInterfaceAddressEntity>? Container { get; set; }
    private string Title { get; set; } = Global.Name;
    private List<BreadcrumbItem> Breadcrumbs { get; } = new();
    private string? Search { get; set; }

    protected override async Task OnInitializedAsync()
    {
        if (string.IsNullOrWhiteSpace(HostId) || ObjectId.TryParse(HostId, out var hostId) is false)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        var host = await Database.Host()
            .Find(Builders<HostEntity>
            .Filter
            .Eq(p => p.Id, HostId))
            .FirstOrDefaultAsync(default);

        if (host is null)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        Title = $"Hosts » {host.Name} » Addresses｜Insight";
        Breadcrumbs.Add(new BreadcrumbItem("Home", href: Navigation.Home));
        Breadcrumbs.Add(new BreadcrumbItem("Hosts", href: Navigation.Management.Hosts.Index));
        Breadcrumbs.Add(new BreadcrumbItem(host.Name, href: Navigation.Management.Hosts.DetailsHref(HostId)));
        Breadcrumbs.Add(new BreadcrumbItem("Addresses", href: "#", true));
    }

    private async Task<TableData<HostInterfaceAddressEntity>> LoadDataAsync(TableState state)
    {
        try
        {
            var filter = Builders<HostInterfaceAddressEntity>.Filter.Eq(p => p.Host, HostId);

            if (string.IsNullOrWhiteSpace(Search) is false)
            {
                var regex = new BsonRegularExpression(new Regex(Search, RegexOptions.IgnoreCase));
                filter &= Builders<HostInterfaceAddressEntity>.Filter.Regex(x => x.Address, regex) |
                Builders<HostInterfaceAddressEntity>.Filter.Regex(x => x.Mask, regex) |
                Builders<HostInterfaceAddressEntity>.Filter.Regex(x => x.Interfaces.First().Description, regex);
            }

            var query = Database.HostInterfaceAddress()
                .Aggregate()
                .Match(filter)
                .Lookup<HostInterfaceAddressEntity, HostInterfaceEntity, HostInterfaceAddressEntity>(Database.HostInterface(), p => p.Interface, p => p.Id, p => p.Interfaces)
                .Sort(state.SortDirection switch
                {
                    SortDirection.Ascending => state.SortLabel switch
                    {
                        "Address" => Builders<HostInterfaceAddressEntity>.Sort.Ascending(p => p.Address),
                        "Mask" => Builders<HostInterfaceAddressEntity>.Sort.Ascending(p => p.Mask),
                        "Interface" => Builders<HostInterfaceAddressEntity>.Sort.Ascending(p => p.Interfaces.First().Description),
                        _ => null
                    },
                    SortDirection.Descending => state.SortLabel switch
                    {
                        "Address" => Builders<HostInterfaceAddressEntity>.Sort.Descending(p => p.Address),
                        "Mask" => Builders<HostInterfaceAddressEntity>.Sort.Descending(p => p.Mask),
                        "Interface" => Builders<HostInterfaceAddressEntity>.Sort.Descending(p => p.Interfaces.First().Description),
                        _ => null
                    },
                    _ => Builders<HostInterfaceAddressEntity>.Sort.Ascending(p => p.Address)
                });

            var countResult = await query.Count().FirstOrDefaultAsync(default);

            return new TableData<HostInterfaceAddressEntity>()
            {
                TotalItems = countResult is null ? 0 : (int)countResult.Count,
                Items = await query.Skip(state.Page * state.PageSize).Limit(state.PageSize).ToListAsync(default)
            };
        }
        catch (Exception)
        {
            Notification.Error(Snackbar);
            return new TableData<HostInterfaceAddressEntity>();
        }
    }
}